#!/usr/bin/python
#coding:latin1
import os, glob,re
rx_class  = re.compile(r"^\s*class\s+ (?P<class>[_a-zA-Z]\w*)\s*(\((?P<base>[\w,.\s]+)\))?",re.X)
rx_def    = re.compile(r"^\s*def\s+(?P<name>([_a-zA-Z]\w*))\s*\((?P<params>[^)]*)\)")
rx_meth   = re.compile(r"^\s*def\s+(?P<method_name>([_a-zA-Z]\w*))\s*\(self[,\s]*(?P<params>[^)]*)\)",re.X)
rx_attr   = re.compile(r"self\.(?P<attr>[_a-zA-Z]\w*)",re.X)


def makedirs(path):
    try:
        os.makedirs(path)
    except Exception, e:
        #print e
        pass

LOGDIR = "log"
MODELPATH = 'model/model.txt'

makedirs(LOGDIR)
makedirs(os.path.split(MODELPATH)[0])

sourcenames = glob.glob("source/*.py")


def genmodel(classes):
    content = ""
    indent = 4 * ' '
    package_ = None
    for ck, cv in sorted(classes.items()):
        cname,cbase= ck
        package,cname = cname.split('.')
        if package != package_:
            content += "P %s%s\n" % (0 * indent, package)
            package_ = package    
        content += "C %s%s\n" % (1 * indent, cname)
        for bname in cbase:
            if bname:
                content += "B %s%s\n" % (1 * indent, bname)
        meths,attrs = cv
        for (method_name ,params) in sorted(meths):
            method_name            
            content += 'm %s%s\n' % (2 * indent, method_name)
            for param in params:
                content += 'p %s%s\n' % (3 * indent, param)
        for attr in sorted(attrs):
            content += 'a %s%s\n' % (2 * indent, attr)        
    return content


allclasses={}

for filepath in sourcenames:
    filename = os.path.split(filepath)[1]
    modul = filename[:-3]
    fr = open(filepath)
    fw = open(os.path.join(LOGDIR, filename), 'w')
    print filename
    
    classes={}
    this_class = None
    for line in fr:
        line = line.rstrip()
        if line:
            mo_def   = rx_def.match(line)
            mo_meth  = rx_meth.match(line)
            mo_class = rx_class.match(line)
            if mo_class:
                fw.write("%s\n" % line)
                base = mo_class.group("base") or ""
                bases = tuple([x.strip() for x in base.split(',')])
                this_class = (modul.lower() + '.' + mo_class.group("class"),bases)                                
                classes[(this_class)] = [{},{}]
            elif mo_def:
                fw.write("%s\n" % line)
                if mo_meth:               
                    method_name = mo_meth.group("method_name")                    
                    params = re.split(' *, *', mo_meth.group("params"))    
                    params = tuple([p.split('=')[0] for p in params if p])
                    #print 999, params
                    classes[this_class][0][(method_name,params)] = True 
                else:
                    print line
            else:
                iter_attr = rx_attr.finditer(line)
                for mo in iter_attr:
                    attr = mo.group("attr")
                    try:
                        classes[this_class][1][attr] = True 
                    except:
                        print line
                        print this_class
                    fw.write("%s\n" % line)

    fr.close()

    fw.write(genmodel(classes))
    allclasses.update(classes)        
    fw.close()


fw_mod = open(MODELPATH,'w')
fw_mod.write(genmodel(allclasses)) 
fw_mod.close()

    
